unit UnidadMPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, inifiles, registry, shellapi;

type
  TFormMPrincipal = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    TxtClave: TEdit;
    LArranques: TLabel;
    BApagar: TBitBtn;
    BAceptar: TBitBtn;
    LI: TLabel;
    Panel2: TPanel;
    PInfo: TPanel;
    PContenedor: TPanel;
    Panel3: TPanel;
    Memo1: TMemo;
    Panel4: TPanel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    TxtCambioClave1: TEdit;
    TxtCambioClave2: TEdit;
    BCambiaClave: TBitBtn;
    GroupBox2: TGroupBox;
    BQuitar: TBitBtn;
    BPoner: TBitBtn;
    Panel5: TPanel;
    TxtParametros: TMemo;
    Panel6: TPanel;
    Panel7: TPanel;
    BitBtn2: TBitBtn;
    BArranques: TBitBtn;
    Timer1: TTimer;
    LWEB: TLabel;
    procedure BApagarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure guardaInicio(eliminar : boolean);
    procedure ejecutarExplorer ();
    procedure Restaurar ();
    function compruebaParametros () : boolean;
    procedure muestraAvanzado ();
    procedure guardaValores(laclave : string; elcontador : integer;
       contador, clave : boolean);
    function rutaWindows() : String;
    procedure systemINI (ponerExplorer : boolean);

    procedure TxtClaveKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure BCambiaClaveClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure TxtCambioClave2KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BQuitarClick(Sender: TObject);
    procedure BPonerClick(Sender: TObject);
    procedure BArranquesClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    quitadaDeInicio : boolean;
    pasa : boolean;
    contador : integer;
    claveleida : string;
    otraclave : string;
    arranques : integer;
    hacer : string;
      { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMPrincipal: TFormMPrincipal;

implementation

function RegisterServiceProcess (dwProcessID, dwType: DWord) : DWord;
  stdcall; external 'KERNEL32.DLL';


{$R *.DFM}

procedure TFormMPrincipal.BApagarClick(Sender: TObject);
begin
  try
    ExitWindowsEx (1,0);
  finally
    ExitWindowsEx (1,0);
  end;
end;

procedure TFormMPrincipal.systemINI (ponerExplorer : boolean);
begin
  try
    if not FileExists(rutaWindows() + '\system.ini') then
    begin
      application.MessageBox ('No se ha encontrado la ruta y el fichero para realizar cambio de estado.',
          'Cambio de estado...', MB_OK + MB_ICONINFORMATION);
    end
    else
    begin
      with TIniFile.Create(rutaWindows() + '\system.ini') do
      try
        if ponerExplorer then
          WriteString('boot', 'shell', 'explorer.exe')
        else
        begin
          if (uppercase(application.ExeName[1]) = 'A') or
              (uppercase(application.ExeName[1]) = 'B') or
              (uppercase(application.ExeName[1]) = 'D') or
              (uppercase(application.ExeName[1]) = 'E') or
              (uppercase(application.ExeName[1]) = 'F') or
              (uppercase(application.ExeName[1]) = 'G') or
              (uppercase(application.ExeName[1]) = 'H') or
              (uppercase(application.ExeName[1]) = 'I') or
              (uppercase(application.ExeName[1]) = 'J') or
              (uppercase(application.ExeName[1]) = 'K') then
            application.MessageBox ('Va a instalar la clave en una unidad ' +
                'distinta de C: (probablemente flexible), esto es PELIGROSO.',
                'Atencin, ACCIN PELIGROSA...', MB_OK + MB_ICONEXCLAMATION);
          WriteString('boot','shell', application.ExeName);
        end;  
      finally
        free;
      end;
    end;
  except
    raise
  end;
end;

procedure TFormMPrincipal.ejecutarExplorer ();
begin
  ShellExecute(Handle, Nil, PChar(rutawindows() + '\explorer.exe'),
    Nil, Nil, SW_NORMAL);
end;

procedure tformmprincipal.guardaInicio(eliminar : boolean);
begin
  systemINI (eliminar)
end;

procedure TFormMPrincipal.Restaurar ();
var
  dummy : integer;
  hTaskBar: THandle;
begin
  application.ProcessMessages;
  ClipCursor(nil);
  hTaskBar := FindWindow('Shell_TrayWnd', nil);
  ShowWindow(hTaskBar, SW_SHOW);
  ShowWindow(FindWindow(nil, 'Program Manager'), SW_SHOW);
  SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0, @dummy, 0);
end;

function TFormMPrincipal.rutaWindows() : string;
var
  reg : tregistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion', False);
  result :=  Reg.ReadString('SystemRoot');
end;

procedure tformmprincipal.muestraAvanzado ();
var
  resultado : string;
  activo : boolean;
begin
  FormMPrincipal.Width := screen.Width;
  FormMPrincipal.Height := screen.Height;
  FormMPrincipal.Position := poScreenCenter;
  formmprincipal.Panel1.Visible := false;
  formmprincipal.panel2.visible := true;
  //comprobar si est activo
  Panel2.Align := alClient;
  with TIniFile.Create(rutaWindows() + '\system.ini') do
  try
    resultado := readString('boot','shell', '')
  finally
    free;
  end;
  if resultado = application.exename then
    activo := true
  else
    activo := false;
  bponer.enabled := not activo;
  BQuitar.Enabled := activo;
end;


function tformmprincipal.compruebaParametros () : boolean;
begin
  if hacer = 'cambioclave' then
  begin
    if txtclave.text = claveleida then
    begin
      txtclave.text := '';
      Li.caption := 'Introduce la nueva clave.';
      hacer := 'cambioclave2';
      txtclave.SelectAll;
      txtclave.setfocus;
      result := false;
      exit;
    end
    else
    begin
      li.caption := 'Clave incorrecta, introduce la clave para continuar.';
      hacer := '';
      result := false;
      exit;
    end;
  end;
  if hacer = 'cambioclave2' then
  begin
    li.caption := 'Reintroduce la nueva clave.';
    otraclave := txtclave.text;
    txtclave.text := '';
    hacer := 'cambioclave3';
    result := false;
    exit;
  end;
  if hacer = 'cambioclave3' then
  begin
    if txtclave.text = otraclave then
    begin
      guardaValores(txtclave.text, 0, false, true);
      hacer := '';
      claveleida := otraclave;
      result := true;
      exit;
    end
    else
    begin
      txtclave.text := '';
      li.caption := 'La clave reintroducida no coincide.';
      hacer := '';
      result := false;
      exit;
    end;
  end;
  if txtclave.text = 'ayapcambioclavep' then
  begin
    contador := 0;
    li.caption := 'Introduce la clave actual.';
    hacer := 'cambioclave';
    txtclave.text := '';
    txtclave.SetFocus;
    result := false;
    exit;
  end;
  if uppercase(txtclave.text) = 'AJPDYARN' then
  begin
    contador := 0;
    hacer := '';
    pasa := true;
    result := true;
    exit;
  end;
  if LowerCase(txtclave.text) = 'ayapadministradorp' then
  begin
    contador := 0;
    hacer := '';
    pasa := true;
    restaurar();
    if application.MessageBox ('Modo avanzado?', 'Administrador...',
        MB_YESNO + MB_ICONQUESTION) = ID_YES then
    begin
      muestraAvanzado ();
      result := false;
      exit;
    end
    else
      result := true;
    exit;
  end;
  if txtclave.text = 'ayapreiniciararranquesp' then
  begin
    guardaValores('', 0, true, false);
    LI.caption := 'El contador se ha iniciado a cero.';
    larranques.Caption := '';
    result := false;
    exit;
  end;
  if txtclave.text = 'ayapdesactivariniciop' then
  begin
    BQuitarClick(nil);
    LI.caption := 'El programa se ha quitado de inicio.';
    result := false;
    exit;
  end;
  if txtclave.text = 'ayapactivariniciop' then
  begin
    BPonerClick(nil);
    LI.caption := 'El programa se ha puesto en inicio.';
    result := false;
    exit;
  end;

  result := true;
end;

//encriptar datos
function Encript(aStr: String; aKey: Integer): String;
begin
   Result:='';
   RandSeed:=aKey;
   for aKey:=1 to Length(aStr) do
       Result:=Result+Chr(Byte(aStr[aKey]) xor random(256));
end;

//desencriptar datos
function Desencript(aStr: String; aKey: Integer): String;
begin
   Result:='';
   RandSeed:=aKey;
   for aKey:=1 to Length(aStr) do
       Result:=Result+Chr(Byte(aStr[aKey]) xor random(256));
end;

procedure tformmprincipal.guardaValores(laclave : string; elcontador : integer;
    contador, clave : boolean);
begin
  //encriptar la clave
  laclave := encript(laclave, 9);
  with TIniFile.Create(rutaWindows() + '\win.ini') do
  try
    if clave then
      WriteString('InicioyCia','Valor', laclave);
    if contador then
      WriteInteger('InicioyCia','Arranques', elcontador);
  finally
    free;
  end;
end;

procedure TFormMPrincipal.BAceptarClick(Sender: TObject);
var
  clave : string;
  programaPuesto : string;
begin
  with TIniFile.Create(rutaWindows() + '\system.ini') do
  try
    programaPuesto := readString('boot', 'shell', 'explorer.exe')
  finally
    free;
  end;
  if not compruebaParametros() then
    exit;
  //desencriptar la clave
  clave := txtclave.text;
  if clave = claveleida then
    pasa := true;
  if uppercase(programapuesto) = 'EXPLORER.EXE' then
  begin
    if application.MessageBox (pchar('La clave no est instalada. Desea instalarla desde el nombre y ruta: ' +
        application.exename + '?'),
        'Instalar clave...', MB_YESNO + MB_ICONQUESTION) = ID_YES then
    guardaInicio (false);
  end
  else
  begin
    if pasa then
    begin
      systemINI (true);
      FormMPrincipal.Visible := false;
      restaurar();
      ejecutarExplorer;
      Application.ProcessMessages;
      Timer1.Enabled := true;
    end
    else
    begin
      if contador >= 2 then
        bapagarclick(nil)
      else
      begin
        contador := contador + 1;
        li.Caption := 'Intento: ' + inttostr(contador) + ' de 3';
        txtclave.SelectAll;
        txtclave.setfocus;
      end;
    end;
  end;
end;

procedure TFormMPrincipal.FormCreate(Sender: TObject);
var
  reg : tregistry;
  programaPuesto : string;
begin
  with TIniFile.Create(rutaWindows() + '\system.ini') do
  try
    programaPuesto := readString('boot','shell', 'explorer.exe')
  finally
    free;
  end;
  if uppercase(programapuesto) = 'EXPLORER.EXE' then
  begin
    if application.MessageBox (pchar('La clave no est instalada. Desea instalarla desde el nombre y ruta: ' +
        application.exename + '?'),
        'Instalar clave...', MB_YESNO + MB_ICONQUESTION) = ID_YES then
    guardaInicio (false);
  end;

  quitadaDeInicio := false;
  RegisterServiceProcess(GetCurrentProcessID,1);
  FormMPrincipal.Height := 170;
  FormMPrincipal.Width := 351;
  hacer := '';
  contador := 0;
  arranques := 0;
  show;
  pasa := false;
  //ruta de Windows
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_LOCAL_MACHINE;
  with TIniFile.Create(rutaWindows() + '\win.ini') do
  begin
    claveleida :=  readString ('InicioyCia','Valor', '');
    //desencriptar la clave
    claveleida := desencript(claveleida, 9);
    arranques :=  readinteger ('InicioyCia','Arranques', 0);
    if claveleida = '' then
    begin
      systemINI(false);
      LI.caption:= 'No tiene clave, aada una clave ahora.';
      WriteString('InicioyCia','Valor', claveleida);
    end;
    Writeinteger('InicioyCia','Arranques', arranques + 1);
    if arranques = 0 then
      guardaInicio(false);
    Reg.Free;
  end;
  if arranques = 0 then
    larranques.Caption := 'Es la primera vez que arrancas Windows.'
  else
    larranques.Caption := inttostr(arranques + 1) + ' ejecuciones.';
end;

procedure TFormMPrincipal.TxtClaveKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    BAceptarClick(nil);
end;

procedure bloquea (todo : boolean);
var
  hTaskBar: THandle;
  dummy : integer;
begin
  //ocultar barra de tareas
  hTaskBar := FindWindow('Shell_TrayWnd', nil);
  ShowWindow(hTaskBar, SW_HIDE);
 //ocultar iconos de escritorio
  ShowWindow(FindWindow(nil, 'Program Manager'), SW_HIDE);
  if todo then
    //deshabilitar Control + Alt + Suprimir
    if not SystemParametersInfo(SPI_SCREENSAVERRUNNING, 1, @dummy, 0) then
      SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0, @dummy, 0);
end;

procedure TFormMPrincipal.FormShow(Sender: TObject);
var
  Rectangulo: TRect;
begin
  //restringir el ratn a una zona determinada
  With Rectangulo do
  begin
    Left := (screen.Width - formmprincipal.Width) div 2;
    Right := ((screen.Width - formmprincipal.Width) div 2) +
        FormMPrincipal.Width;
    Top := (screen.Height - formmprincipal.Height) div 2;
    Bottom := ((screen.Height - formmprincipal.Height) div 2) +
        FormMPrincipal.Height;
  end;
  ClipCursor(@Rectangulo);
  bloquea(true);
  TxtClave.setfocus;
end;

procedure TFormMPrincipal.BCambiaClaveClick(Sender: TObject);
begin
  if (TxtCambioClave1.text = TxtCambioClave2.text) and (TxtCambioClave1.text = '') then
  begin
    guardaValores (txtcambioclave1.text, 0, false, true);
    application.MessageBox ('La clave se ha cambiado correctamente.' +
        ' Recuerde que ha introducido una clave vaca.',
      'Cambio de clave...', MB_OK + MB_ICONINFORMATION);
  end
  else
  begin
    if TxtCambioClave1.text = TxtCambioClave2.text then
    begin
      guardaValores (txtcambioclave1.text, 0, false, true);
      application.MessageBox ('La clave se ha cambiado correctamente.',
        'Cambio de clave...', MB_OK + MB_ICONINFORMATION);
    end
    else
    begin
      application.MessageBox ('Las claves no coinciden.',
        'Cambio de clave...', MB_OK + MB_ICONHAND);
    end;
  end;
end;

procedure TFormMPrincipal.BitBtn2Click(Sender: TObject);
begin
  systemINI (true);
  FormMPrincipal.Visible := false;
  restaurar();
  ejecutarExplorer;
  Application.ProcessMessages;
  if not quitadaDeInicio then
    Timer1.Enabled := true
  else
    close;
end;

procedure TFormMPrincipal.TxtCambioClave2KeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    BCambiaClaveClick(nil);
end;

procedure TFormMPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if not pasa then
    BApagarClick(nil);
end;

procedure TFormMPrincipal.BQuitarClick(Sender: TObject);
begin
  guardaInicio(true);
  quitadadeinicio := true;
  application.MessageBox ('Se ha eliminado correctamente de inicio.',
       'Eliminacin de inicio...', MB_OK + MB_ICONINFORMATION)
end;

procedure TFormMPrincipal.BPonerClick(Sender: TObject);
begin
  guardaInicio (false);
  application.MessageBox ('Se ha puesto en inicio correctamente.',
      'Activar en inicio...', MB_OK + MB_ICONINFORMATION);
end;

procedure TFormMPrincipal.BArranquesClick(Sender: TObject);
begin
  if application.MessageBox ('Desea poner el contador de arranques a 0?',
      'Iniciar contador de arranques...', MB_YESNO + MB_ICONQUESTION) = ID_YES then
    guardaValores ('', 0, true, false);
end;

procedure TFormMPrincipal.FormDestroy(Sender: TObject);
begin
  if not pasa then
    BApagarClick(nil);
end;

procedure TFormMPrincipal.Timer1Timer(Sender: TObject);
begin
  systemINI(false);
  close;
end;

procedure TFormMPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.

